<template>
  <table class="border-radius">
    <thead class="border-radius">
      <tr>
        <th class="indexCol"></th>
        <th
          v-for="key in columns"
          @click="sortBy(key)"
          :class="{ active: sortKey == key }"
          :key="key.test"
        >
          {{ key }}
          <img
            class="arrow"
            :src="require('@/assets/gridIcons/up-arrow.png')"
            :class="sortOrders[key] > 0 ? 'asc' : 'dsc'"
          />
        </th>
        <th v-if="this.columns.includes('route')">acties</th>
        <th class="buttonCol"></th>
      </tr>
    </thead>
    <tbody>
      <tr v-for="(entry, index) in pageData" :key="entry">
        <th class="indexCol">{{ index + 1 }}</th>
        <td v-for="key in columns" :key="key">
          <ProgressBar
            v-if="key == 'status' && entry[key] != null"
            :percentage="entry[key]"
          ></ProgressBar>
          <p v-else-if="key == 'status'">Geen acties vereist</p>
          <img
            class="commentIndicator"
            v-else-if="key == 'opmerking'"
            :src="require('@/assets/gridIcons/' + commentIndicator(entry[key]))"
          />
          <p v-else>
            {{ entry[key] }}
          </p>
        </td>
        <td v-if="this.columns.includes('route')">
          <Icon
            @click="editBuilding(entry['id'])"
            class="icons"
            icon="bx:edit"
          />
          <Icon
            v-if="this.confirm != entry['id']"
            @click="confirmate(entry['id'])"
            class="icons"
            color="red"
            icon="pajamas:remove"
          />
          <Icon
            v-if="this.confirm == entry['id']"
            @click="deleteBuilding(entry['id'])"
            class="icons"
            icon="line-md:confirm"
            color="red"
          />
        </td>
        <td class="buttonCol">
          <button @click="navigate(entry)">Details</button>
        </td>
      </tr>
    </tbody>
  </table>
  <div class="paginationRow">
    <span class="pageButton">
      <span v-show="page > 1" @click="page--"> &lt; Vorige pagina </span>
    </span>
    <p>Pagina {{ page }} van {{ Math.ceil(filteredData.length / pageSize) }}</p>
    <span class="pageButton">
      <span
        v-show="page < Math.ceil(filteredData.length / pageSize)"
        @click="page++"
      >
        Volgende pagina &gt;
      </span>
    </span>
  </div>
</template>

<script>
import ProgressBar from "../atoms/ProgressBar.vue";
import { Icon } from "@iconify/vue";
import axios from "axios";
export default {
  components: { ProgressBar, Icon },
  props: {
    data: {
      Type: Array,
    },
    columns: {
      Type: Array,
    },
    filterKey: {
      Type: String,
    },
  },
  data: function () {
    var sortOrders = {};
    this.columns.forEach(function (key) {
      sortOrders[key] = 1;
    });
    return {
      confirm: "",
      sortKey: "",
      sortOrders: sortOrders,
      page: 1,
      pageSize: 10,
    };
  },
  computed: {
    filteredData: function () {
      var sortKey = this.sortKey;
      var filterKey = this.filterKey && this.filterKey.toLowerCase();
      var order = this.sortOrders[sortKey] || 1;
      var data = this.data;
      if (filterKey) {
        data = data.filter(function (row) {
          return Object.keys(row).some(function (key) {
            return String(row[key]).toLowerCase().indexOf(filterKey) > -1;
          });
        });
      }
      if (sortKey) {
        data = data.slice().sort(function (a, b) {
          a = a[sortKey];
          b = b[sortKey];
          return (a === b ? 0 : a > b ? 1 : -1) * order;
        });
      }
      return data;
    },
    pageData: function () {
      return this.filteredData.slice(
        (this.page - 1) * this.pageSize,
        this.page * this.pageSize
      );
    },
  },
  filters: {
    capitalize: function (str) {
      return str.charAt(0).toUpperCase() + str.slice(1);
    },
  },
  methods: {
    pageDatas() {},
    sortBy: function (key) {
      this.sortKey = key;
      this.sortOrders[key] = this.sortOrders[key] * -1;
    },
    navigate(entry) {
      window.location.href = window.location.href + "/" + entry.id;
    },
    confirmate(entryid) {
      this.confirm = entryid;
    },
    commentIndicator: function (value) {
      switch (value) {
        case 0:
          return "noComment.png";
        case 1:
          return "newComment.png";
        case 2:
          return "solvedComment.png";
        default:
          return "noComment.png";
      }
    },
    editBuilding(id) {
      if (this.$route.name == "buildings") {
        this.$router.push({ name: "editBuildings", params: { id: id } });
      } else if (this.$route.name == "routes") {
        this.$router.push({ name: "editRoutes", params: { id: id } });
      }
    },
    async deleteBuilding(id) {
      if (this.$route.name == "buildings") {
        await axios.delete("/api/building/" + id).then((response) => {
          if (response.status === 200) {
            console.log("deleted");
          }
        });
      } else if (this.$route.name == "routes") {
        await axios.delete("/api/round/" + id).then((response) => {
          if (response.status === 200) {
            console.log("deleted");
          }
        });
      }
      window.location.reload();
    },
  },
};
</script>

<style lang="scss" scoped>
table {
  background-color: var(--lighter-grey);
  width: 100%;
  border-collapse: separate !important;
  th,
  td {
    min-width: 120px;
    padding: 10px 20px;
    .icons {
      width: 35px;
      height: 35px;
      padding-left: 6px;
      padding-right: 6px;
    }
  }
  th {
    background-color: var(--lighter-grey);
    color: var(--black);
    font-weight: bold;
    -webkit-user-select: none;
    -moz-user-select: none;
    -ms-user-select: none;
    user-select: none;
    opacity: 0.66;
    &.active {
      opacity: 1;
      color: var(--almost-black);
      .arrow {
        opacity: 1;
        display: inline-block;
      }
    }
  }

  td {
    background-color: transparent;
  }
}
tr {
  background-color: white;
}

tr:hover {
  background-color: var(--lighter-grey);
}

.arrow {
  display: none;
  vertical-align: middle;
  width: 1rem;
  height: 1rem;
  margin-left: 5px;
  opacity: 0.66;
  &.dsc {
    transform: rotate(180deg);
  }
}
.commentIndicator {
  width: 2rem;
}

.indexCol {
  min-width: auto;
  width: 1rem;
}
.buttonCol {
  min-width: auto;
  width: 1rem;
  button {
    border-radius: 0.5rem;
    background: var(--almost-black);
    color: var(--lighter-grey);
  }
}
.paginationRow {
  display: flex;
  flex-direction: row;
  justify-content: space-evenly;
  background-color: var(--lighter-grey);
  border-radius: 0 0 5px 5px;

  width: 100%;
  height: 2rem;
}
.pageButton {
  cursor: pointer;
  &:hover {
    color: var(--light-grey);
  }
  min-width: 7rem;
}
</style>
